from __future__ import division
from visual import *
scene.range = 6e-9
scene.width = 800
scene.height = 800

'''
Developed by Zakary T. Noel- February 2015
'''
def drawGrid():
    ##  CONSTANTS
    gridsep = griddim/gridscale
    ##  OBJECTS
    gridarea = box(pos=vector(0,0,0),height=griddim,length=griddim,width=1e-30,color=color.white)
    ## Lines...
    #Vertical
    xl = -griddim/2 + gridsep/2
    while xl < griddim/2:
        cyl = xl
        if cyl < gridsep and cyl > -gridsep:
            cylinder(pos=vector(xl,griddim/2,0),axis=vector(0,-griddim,0),radius=.2e-10,color=color.black)
        else:
            cylinder(pos=vector(xl,griddim/2,0),axis=vector(0,-griddim,0),radius=.2e-10,color=(.7,.7,.7))
        xl = xl + gridsep

    #Horizontal
    xl = -griddim/2 + gridsep/2
    while xl < griddim/2:
            cyl = xl
            if cyl < gridsep and cyl > -gridsep:
                cylinder(pos=vector(-griddim/2,xl,0),axis=vector(griddim,0,0),radius=.2e-10,color=color.black)
            else:
                cylinder(pos=vector(-griddim/2,xl,0),axis=vector(griddim,0,0),radius=.2e-10,color=(.7,.7,.7))
            xl = xl + gridsep

def drawEField():
    ## calculations
    theta = 0
    while theta < 2*pi:

        rate(2) # tell computer to go through loop slowly
        ## Calculate observation location (tail of arrow) using current value of theta:
        Earrow = arrow(pos=R*vector(cos(theta),sin(theta),0), axis=vector(1e-10,0,0), color=color.orange)
        VLabel = label(pos = Earrow.pos)## write instructions below to tell the computer how to calculate the correct
        ## net electric field Enet at the observation location (the position of Earrow):
        r1=Earrow.pos-plus.pos
        rmag1=sqrt(r1.x**2+r1.y**2+r1.z**2)
        rhat1 = (r1/rmag1)
        # 9e-9 * q Rhat / r^2
        E1 = (oofpez * (qplus/rmag1**2) * rhat1)
        Earrow.axis=E1*scalefactor
        V1 = (oofpez * (qplus/rmag1))

        r2=Earrow.pos-neg.pos
        rmag2=sqrt(r2.x**2+r2.y**2+r2.z**2)
        rhat2 = (r2/rmag2)
        E2 = (oofpez * (qneg/rmag2**2) * rhat2)
        Earrow.axis=E2*scalefactor
        V2 = (oofpez * (qneg/rmag2))
        

        Enet = E1 + E2
        Vnet = V1 + V2
        Earrow.axis=Enet*scalefactor
        VLabel.text = str(Vnet)

        print(Enet)
                     
        ## change the axis of Earrow to point in the direction of the electric field at that location

       ## and scale it so it looks reasonable

        ## Assign a new value to theta
        theta = theta + pi/6



gridscale = 21 #An odd number will give a centered origin point
griddim = 1e-8
drawGrid()
##constants
oofpez = 9e9 # stands for One Over Four Pi Epsilon-Zero
qe = 1.6e-19 # proton charge
s = 4e-10 # charge separation
R = 3e-9 # display Enet on a circle of radius R
scalefactor = 2.0e-17 # for scaling arrows to represent electric field

## objects
## Represent the two charges of the dipole by red and blue spheres:
plus = sphere(pos=vector(s/2,0,0), radius=1e-10, color=color.red)
qplus = qe # charge of positive particle
neg = sphere(pos=vector(-s/2,0,0), radius=1e-10, color=color.blue)
qneg = -qplus # charge of negative particle

drawEField()
